/*
 Role.java
  
 Created on Apr 3, 2008 by Richard Johansson (richard@cs.lth.se).

 $Log: Role.java,v $
 Revision 1.2  2009/04/16 13:32:13  johansson
 Serializable.

 Revision 1.1  2009/01/16 14:50:55  johansson
 Added to brenta repository.

 Revision 1.2  2008/05/29 11:51:18  richard
 Default roleset.

 Revision 1.1  2008/04/07 07:32:13  richard
 Added.

   
 */
package se.lth.cs.nlp.depsrl.format;

import java.io.Serializable;

import org.w3c.dom.*;

/**
 * @author Richard Johansson (richard@cs.lth.se)
 */
public class Role implements Serializable {

	private static final long serialVersionUID = 0L;
	
    Role(Element el) {
        id = el.getAttribute("n");
        if(id == null || id.equals(""))
            throw new IllegalArgumentException("no n in role");
        descr = el.getAttribute("descr");
        if(descr != null && descr.equals(""))
            descr = null;
        NodeList l = el.getElementsByTagName("vnrole");
        if(l.getLength() > 0) {
            Element el2 = (Element) l.item(0);
            vncls = el2.getAttribute("vncls");
            vntheta = el2.getAttribute("vntheta");
        }
    }

    /* Default for unknown predicates. */
    Role(int i) {
        id = "" + i;
    }
    
    public String id;
    public String descr;
    
    public String vncls;
    public String vntheta;

    public String toString() {
        String out = "(id = " + id + ", descr = " + descr;
        if(vncls != null)
            out += ", vncls = " + vncls + ", vntheta = " + vntheta;
        out += ")";
        return out;
    }
    
}
