
if [ x$WORK_DIR = x ]; then
    echo "no work dir given"
    exit 1
fi

pwd

touch $WORK_DIR/doing
rm -f $WORK_DIR/before
sync

JSONDIR=../nlputils/external/json
CP=unitn_opinion_epe.jar:$JSONDIR/commons-beanutils-1.8.3.jar:$JSONDIR/commons-collections-3.2.1.jar:$JSONDIR/commons-lang-2.5.jar:$JSONDIR/commons-logging-1.1.1.jar:$JSONDIR/ezmorph-1.0.6.jar:$JSONDIR/json-lib-2.4-jdk15.jar:../nlputils/external/trove.jar

MODE=EPE
DIR=database.mpqa.2.0
MPQA_LEX=epe_configs/subjclueslen1-HLTEMNLP05.tff
SEQ_TEMPLATE=epe_configs/template_100402b.txt
HOLDER_CONF=epe_configs/holder_110421b.xml

TRAIN_LIST=doclists/richard_smalltrainset.txt
EVAL_LIST=doclists/richard_devset.txt

EPE_DIR_TRAIN=$EPE_DIR/training
EPE_DIR_EVAL=$EPE_DIR/development

CMD1="java -Xmx10G -cp $CP mpqa_structlearn.fullsystem.EPEPipeline -train1 $MODE"
CMD1="$CMD1 $GRAPH_MODE $EPE_FEATURE_SPEC $DIR" 
CMD1="$CMD1 $MPQA_LEX $TRAIN_LIST $EPE_DIR_TRAIN $WORK_DIR $SEQ_TEMPLATE $HOLDER_CONF"

CMD2="java -Xmx10G -cp $CP mpqa_structlearn.fullsystem.EPEPipeline -train2 $MODE"
CMD2="$CMD2 $GRAPH_MODE $EPE_FEATURE_SPEC $DIR" 
CMD2="$CMD2 $MPQA_LEX $TRAIN_LIST $EPE_DIR_TRAIN $WORK_DIR $SEQ_TEMPLATE $HOLDER_CONF"

CMD3="java -Xmx10G -cp $CP mpqa_structlearn.fullsystem.EPEPipeline -eval $MODE"
CMD3="$CMD3 $GRAPH_MODE $EPE_FEATURE_SPEC $DIR"
CMD3="$CMD3 $MPQA_LEX $EVAL_LIST $EPE_DIR_EVAL $WORK_DIR"

echo $CMD1
$CMD1
if [ $? -ne 0 ]; then
    echo "Step 1 exited with code $?."
    exit 1
fi
sync

echo $CMD2
$CMD2
if [ $? -ne 0 ]; then
    echo "Step 2 exited with code $?."
    exit 1
fi
sync

echo $CMD3
$CMD3
if [ $? -ne 0 ]; then
    echo "Eval step exited with code $?."
    exit 1
fi

rm -f $WORK_DIR/doing
touch $WORK_DIR/done

sync



#java -Xmx10G -cp $CP mpqa_structlearn.fullsystem.EPEPipeline -train1 $MODE \
#     $GRAPH_MODE $EPE_FEATURE_SPEC $DIR \
#     $MPQA_LEX $TRAIN_LIST $EPE_DIR_TRAIN $WORK_DIR $SEQ_TEMPLATE $HOLDER_CONF \
#&& sync \
#&& java -Xmx10G -cp $CP mpqa_structlearn.fullsystem.EPEPipeline -train2 $MODE \
#     $GRAPH_MODE $EPE_FEATURE_SPEC $DIR \
#     $MPQA_LEX $TRAIN_LIST $EPE_DIR_TRAIN $WORK_DIR $SEQ_TEMPLATE $HOLDER_CONF \
#&& sync \
#&& java -Xmx10G -cp $CP mpqa_structlearn.fullsystem.EPEPipeline -eval $MODE \
#     $GRAPH_MODE $EPE_FEATURE_SPEC $DIR \
#     $MPQA_LEX $EVAL_LIST $EPE_DIR_EVAL $WORK_DIR

