/**
 * 
 */
package mpqareader;

public class Intensities {
	public int pos, neu, neg;
	public Intensities(int pos, int neu, int neg) {
		this.pos = pos;
		this.neu = neu;
		this.neg = neg;
	}

	private static int NONE = BOWPolSubjSentClassifier.NONE; 
	
	Intensities(String subjLine) {
		subjLine = subjLine.trim();
		if(subjLine.startsWith("<SUBJ subj=\"false\""))
			pos = neu = neg = NONE;
		else {
			String[] ts = subjLine.split("\"");
			pos = BOWPolSubjSentClassifier.toIntValue(ts[3]);
			neu = BOWPolSubjSentClassifier.toIntValue(ts[5]);			
			neg = BOWPolSubjSentClassifier.toIntValue(ts[7]);
		}
	}
	
	Intensities(String pos, String neu, String neg) {
		this.pos = BOWPolSubjSentClassifier.toIntValueShort(pos);
		this.neu = BOWPolSubjSentClassifier.toIntValueShort(neu);			
		this.neg = BOWPolSubjSentClassifier.toIntValueShort(neg);
	}
	
	public boolean equals(Object o) {
		Intensities other = (Intensities) o;
		return pos == other.pos && neg == other.neg && neu == other.neu;
	}
	
	public String toString() {
		return "(" + pos + "," + neu + "," + neg + ")";
	}
	
	public boolean isSubjective() {
		return pos > NONE || neu > NONE || neg > NONE;
	}
	
}