package mpqa_structlearn.io;

public class EPEFeatureSpec {

    String cposLabel;
    String fposLabel;
    String lemmaLabel;

    public EPEFeatureSpec(String s) {
        String[] ts = s.split(";");
        for(String t: ts) {
            t = t.trim();
            if(t.isEmpty())
                continue;
            if(t.startsWith("c:"))
                cposLabel = t.substring(2); 
            else if(t.startsWith("f:"))
                fposLabel = t.substring(2);
            else if(t.startsWith("l:"))
                lemmaLabel = t.substring(2);
            else
                throw new RuntimeException("Illegal feature spec: " + t);
        }
        
        System.err.println(cposLabel + " / " + fposLabel + " / " + lemmaLabel);
        
    }
    
    public String toString() {
        return "[EPEFeatureSpec: c=" + cposLabel + "; f=" + fposLabel + ", l=" + lemmaLabel + "]"; 
    }
    
}
