package mpqa_structlearn.io;

import java.io.BufferedReader;

import se.lth.cs.nlp.nlputils.core.Util;

public class FixEPEOffsets {

    private static boolean match(String raw, String processed) {
        if(raw.equals("&amp;") && processed.equals("&"))
            return true;
        if(raw.equals("CD&amp;amp;V") && processed.equals("CD&amp;V"))
            return true;
        if(raw.equals("AT&amp;amp;T") && processed.equals("AT&amp;T"))
            return true;
        if(raw.equals("&amp;lt;&amp;gt;") && processed.equals("<>"))
            return true; 
        if(raw.matches(". . .( ?)") && processed.equals("…"))
            return true;
        //if(raw.equals("\")") && processed.equals("”"))
        //    return true;
        
        processed = processed.replace('’', '\'');
        processed = processed.replace('‘', '\'');
        processed = processed.replaceAll("–", "--");
        processed = processed.replaceAll("“", "\"");
        processed = processed.replaceAll("”", "\"");
        processed = processed.replaceAll("…", "...");
        raw = raw.replaceAll("``", "\"");
        raw = raw.replaceAll("''", "\"");
        raw = raw.replaceAll("`", "'");
        return raw.equals(processed);
    }
    
    public static void main(String[] argv) {
        try {
            BufferedReader br1 = Util.openFileReader(argv[0]);
            String txt = Util.readFile(argv[1]);

            int len = txt.length();

            if(false) {
                for(int i = 0; i < len; i++) {
                    char c = txt.charAt(i);
                    if(Character.isWhitespace(c))
                        System.out.println(i + ": [" + (int) c + "]");
                    else
                        System.out.println(i + ": " + c);
                }
                System.exit(1);
            }

            final boolean ADJUST_OFFSET = false;
            
            int offset = ADJUST_OFFSET? Integer.MIN_VALUE: 0;

            int end = -1;
            
            String line = br1.readLine();
            while(line != null) {

                if(line.isEmpty()) {
                    System.out.println();
                    
                    if(false)
                        if(ADJUST_OFFSET)
                            for(int i = end; i < len; i++)
                                if(!Character.isWhitespace(txt.charAt(i))) {
                                    //System.out.println((int) txt.charAt(i));
                                    offset = i;
                                    break;
                                }
                    //System.out.println("new offset: " + offset);
                } else {
                    String[] ss = line.split("\t");

                    int start = Integer.parseInt(ss[0]);
                    end = Integer.parseInt(ss[1]);

                    if(ADJUST_OFFSET && offset == Integer.MIN_VALUE) { // first time
                        int firstPosition = txt.indexOf(ss[2]);
                        if(firstPosition == -1) {
                            System.err.println("|" + ss[2] + "| (l=|" + ss[3] + "|)");
                            System.err.println("|" + txt.substring(0, 10) + "|");

                            firstPosition = txt.indexOf(ss[3]); // backoff using lemma
                            if(firstPosition == -1) {
                                if(ss[2].equals("‘") && ss[3].equals("`")) {
                                    firstPosition = txt.indexOf("'"); // another backoff for quotes
                                }
                                if(firstPosition == -1)
                                    throw new RuntimeException("??");
                            }
                        }
                        offset = firstPosition - start;
                        //System.out.println("offset = " + offset);
                    }
                    start += offset;
                    end += offset;
                    
                    String w = txt.substring(start, end);

                    if(w.equals("\")") || w.equals("\"]")) {

                        System.err.println("quote/bracket bug; trying to fix");
                        
                        if(ss[2].equals("”")) {
                            end -= 1;
                        } else {
                            start += 1;
                        }
                        
                    }
                    
                    if(argv[1].endsWith("ch5.txt") && offset == 168 && ss[2].equals("what")) {
                        System.err.println("ch5 bug");
                        start += 8;
                        end += 8;
                        offset += 8;
                        w = txt.substring(start, end);
                    }
                    
                    //System.out.println(ss[2] + " / " + w);
                    if(!match(w, ss[2])) {
                        
                        // try to recover
                        if(ADJUST_OFFSET)
                            for(int j = start; j < len; j++) {
                                if(!Character.isWhitespace(txt.charAt(j))) {                                
                                    w = txt.substring(start, end);
                                    System.err.println("setting offset to " + offset);
                                    System.err.println("w = |" + w + "|");
                                    break;
                                } else {
                                    start++;
                                    end++;
                                    offset++;
                                }
                            }
                        
                        if(!match(w, ss[2])) {
                            System.err.println("---");
                            System.err.println(line);
                            System.err.println(offset);
                            System.err.println("|" + w + "| / |" + ss[2] + "|");
                            System.err.println(argv[0] + " / " + argv[1]);
                            throw new RuntimeException("?");
                        }
                    }
                    
                    System.out.println(start + "\t" + end + "\t"
                            + ss[2] + "\t" + ss[3] + "\t" + ss[4]);
                }
                
                line = br1.readLine();
            }
            
        } catch(Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
    
}
