package mpqa_structlearn.io;

import java.util.ArrayList;
import java.util.HashMap;

import se.lth.cs.nlp.nlputils.depgraph.DepGraph;

public class MPQAAgent implements java.io.Serializable {
	
	private static final long serialVersionUID = 0L;
	
	public boolean isWriter;
	public boolean isImplicit;

	public String mpqaID;
	
	public ArrayList<MPQAAgentInstance> instances = new ArrayList();

	public String toString() {
	    if(isWriter)
	        return "[(writer)]";
	    else if(isImplicit)
	        return "[(implicit)]";
	    else
	        return instances.toString();
	}

	public String toStringDetailed() {
	    if(isWriter)
            return "[(writer)]";
        else if(isImplicit)
            return "[(implicit)]";
        else {
            StringBuilder out = new StringBuilder("[" + mpqaID + ":");
            for(MPQAAgentInstance inst: instances)
                out.append(" " + inst.toStringDetailed());
            out.append("]");
            return out.toString();
        }
    }
	
	public String toString2(HashMap<MPQASentence, String> senToNbr) {
	    if(isWriter)
            return "[(writer)]";
        else if(isImplicit)
            return "[(implicit)]";
        else {
            StringBuilder sb = new StringBuilder("[");
            boolean first = true;
            for(MPQAAgentInstance i: instances) {
                if(!first)
                    sb.append(", ");
                else
                    first = false;
                sb.append(i.toString2(senToNbr.get(i.containingSentence)));                
            }
            sb.append("]");
            return sb.toString();
        }
	}
	
}
