/**
 * 
 */
package mpqa_structlearn.sequences;

import java.util.ArrayList;

import mpqa_structlearn.io.*;
import se.lth.cs.nlp.nlputils.annotations.*;
import se.lth.cs.nlp.nlputils.core.*;
import se.lth.cs.nlp.nlputils.depgraph.DepGraph;

public class Candidate implements java.io.Serializable {

	private static final long serialVersionUID = 0L;
	
	public double baseScore;
	public PRFStats stats;

	public MPQASentence mpqaSentence;

	public Candidate clone() {
		Candidate out = new Candidate();
		out.baseScore = baseScore;
		if(stats != null)
			out.stats = stats.clone();
		out.mpqaSentence = mpqaSentence.clone();

		out.baseSrcScore = baseSrcScore;
		if(isWriter != null) {
			out.isWriter = isWriter.clone();
			out.isImplicit = isImplicit.clone();
			out.srcIndex = srcIndex.clone();
		}
		
		return out;
	}
	
	// TODO ta bort detta
	
	/* Agents. */
	public double baseSrcScore;
	public boolean[] isWriter;
	public boolean[] isImplicit;
	public int[] srcIndex;

	public double basePolScore;

	public static Candidate fromLayer(AnnotationLayer l, double score, 
			DepGraph dg, ArrayList<String> slClues) {
		Candidate out = new Candidate();
		out.baseScore = score;
		MPQASentence sen = new MPQASentence();
		sen.dg = dg;
		sen.slClues = slClues;
		for(Span s: (ArrayList<Span>) l.spans) {
			MPQAExpression expr = new MPQAExpression();
			expr.type = s.label;
			expr.span = new ArrayList();
			for(int i = s.start; i < s.end; i++)
				expr.span.add(dg.nodes[i+1]);
			expr.containingSentence = sen;
			sen.exprs.add(expr);
		}
		out.mpqaSentence = sen;
		return out;
	}
	
	public static ArrayList<Candidate> convertList(String[][] sen,
			ArrayList<DoubleObjPair<AnnotationLayer>> l) {
		DepGraph dg = new DepGraph(sen);
		ArrayList<String> slClues = new ArrayList();
		slClues.add(null);
		for(int i = 0; i < sen.length; i++)
			slClues.add(sen[i][3]);
		ArrayList<Candidate> out = new ArrayList();
		for(DoubleObjPair<AnnotationLayer> p: l)
			out.add(fromLayer(p.right, p.left, dg, slClues));
		return out;
	}

}