package se.lth.cs.nlp.nlputils.core;

import java.util.*;

public class ArrayComparator<T> implements Comparator<T> {

	private HashMap<T, Integer> orderMap;
	
	public ArrayComparator(T[] arr) {
		orderMap = new HashMap();
		for(int i = 0; i < arr.length; i++)
			orderMap.put(arr[i], i);
	}

	public int compare(T t1, T t2) {
		Integer i1 = orderMap.get(t1);
		if(i1 == null)
			throw new IllegalArgumentException("not listed: " + t1);
		Integer i2 = orderMap.get(t2);
		if(i2 == null)
			throw new IllegalArgumentException("not listed: " + t2);
		return i1 - i2;
	}

}
