/*
 DoubleFunction.java
 
 Created on Feb 9, 2011 by Richard Johansson (johansson@disi.unitn.it).
 
 $Log: DoubleFunction.java,v $
 Revision 1.1  2011-02-10 11:42:45  johansson
 Added.

 
 */
package se.lth.cs.nlp.nlputils.core;

/**
 * A callable one-argument function from T to double.
 * 
 * @author Richard Johansson (johansson@disi.unitn.it)
 */
public abstract class DoubleFunction<T> {
    
    /**
     * Initiation parameter.
     */
    protected Object in;
    
    /**
     * Initiates the function.
     */
    public DoubleFunction() {
    }
    
    /**
     * Initiates the function with a parameter.
     * 
     * @param in an initiation parameter.
     */
    public DoubleFunction(Object in) {
        this.in = in;
    }
    
    /**
     * Calls this function.
     * 
     * @param t the parameter.
     */
    public abstract double apply(T t);
    
}
