/*
 Function.java
 
 Created on Apr 12, 2006 by Richard Johansson (richard@cs.lth.se).
 
 $Log: Function.java,v $
 Revision 1.1  2009/01/16 10:05:11  johansson
 Added to brenta repository.

 Revision 1.2  2006/09/07 17:51:19  richard
 New revision.

 Revision 1.1  2006/05/16 13:38:13  richard
 Re-added because of CVS problems.
 
 Revision 1.1  2006/04/12 12:01:12  richard
 Added the file.
 
 
 */
package se.lth.cs.nlp.nlputils.core;

/**
 * A callable one-argument function from T1 to T2.
 * 
 * @author Richard Johansson (richard@cs.lth.se)
 */
public abstract class Function<T1, T2> {
    
    /**
     * Initiation parameter.
     */
    protected Object in;
    
    /**
     * Initiates the function.
     */
    public Function() {
    }
    
    /**
     * Initiates the function with a parameter.
     * 
     * @param in an initiation parameter.
     */
    public Function(Object in) {
        this.in = in;
    }
    
    /**
     * Calls this function.
     * 
     * @param t the parameter.
     */
    public abstract T2 apply(T1 t);
    
}
