/*
 Generator.java
 
 Created on May 16, 2006 by Richard Johansson (richard@cs.lth.se).
 
 $Log: Generator.java,v $
 Revision 1.1  2009/01/16 10:05:11  johansson
 Added to brenta repository.

 Revision 1.2  2006/09/07 17:51:19  richard
 New revision.

 Revision 1.1  2006/05/16 13:45:07  richard
 Added the file.
 
 
 */
package se.lth.cs.nlp.nlputils.core;

/**
 * A callable zero-argument function.
 * 
 * @author Richard Johansson (richard@cs.lth.se)
 */
public abstract class Generator<T> {
    
    /**
     * Initiation parameter.
     */
    protected Object in;
    
    /**
     * Initiates the function.
     */
    public Generator() {
    }
    
    /**
     * Initiates the function with a parameter.
     * 
     * @param in an initiation parameter.
     */
    public Generator(Object in) {
        this.in = in;
    }
    
    /**
     * Calls this function.
     * 
     * @return the generated value.
     */
    public abstract T apply();
    
}
