/*
 IntIntSetMap.java
  
 Created on Nov 8, 2007 by Richard Johansson (richard@cs.lth.se).

 $Log: IntIntSetMap.java,v $
 Revision 1.1  2009/01/16 10:05:11  johansson
 Added to brenta repository.

 Revision 1.1  2007/11/08 10:10:08  richard
 Added.

   
 */
package se.lth.cs.nlp.nlputils.core;

import java.io.Serializable;
import gnu.trove.*;

/**
 * @author Richard Johansson (richard@cs.lth.se)
 */
public class IntIntSetMap implements Serializable {

    private static final long serialVersionUID = 0;    
    private static final int START_SIZE = 2;
    
    TIntObjectHashMap<TIntHashSet> map = new TIntObjectHashMap();

    public void put(int k, int v) {
        TIntHashSet s = map.get(k);
        if(s == null) {
            s = new TIntHashSet(START_SIZE);
            map.put(k, s);
        }
        s.add(v);
    }

    public void putAll(int k, int[] vs) {
        TIntHashSet s = map.get(k);
        if(s == null) {
            s = new TIntHashSet(START_SIZE);
            map.put(k, s);
        }
        s.addAll(vs);
    }

    public TIntHashSet get(int k) {
        return map.get(k);
    }
    
}
