/*
 NegatedComparator.java
 
 Copyright (C) 2005, Richard Johansson (richard@cs.lth.se).
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.
 
 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 
 Created on Nov 28, 2005 by Richard Johansson (richard@cs.lth.se).
 
 $Log: NegatedComparator.java,v $
 Revision 1.1  2009/01/16 10:05:11  johansson
 Added to brenta repository.

 Revision 1.2  2006/09/07 17:51:19  richard
 New revision.

 Revision 1.1  2006/05/16 13:38:13  richard
 Re-added because of CVS problems.
 
 Revision 1.2  2006/04/07 14:46:08  richard
 Added documentation.
 
 Revision 1.1  2005/11/28 15:41:00  richard
 Added the file.
 
 
 */
package se.lth.cs.nlp.nlputils.core;

import java.util.Comparator;

/**
 * A reversal of a given comparator.
 * @author Richard Johansson (richard@cs.lth.se)
 */
public class NegatedComparator<T> implements Comparator<T> {
    
    private Comparator<T> comparator;
    
    public NegatedComparator(Comparator<T> comparator) {
        this.comparator = comparator;
    }
    
    public int compare(T t1, T t2) {
        return comparator.compare(t2, t1);
    }
    
}
