/*
 Procedure.java
 
 Created on Apr 11, 2006 by Richard Johansson (richard@cs.lth.se).
 
 $Log: Procedure.java,v $
 Revision 1.1  2009/01/16 10:05:11  johansson
 Added to brenta repository.

 Revision 1.2  2006/09/07 17:51:19  richard
 New revision.

 Revision 1.1  2006/05/16 13:38:13  richard
 Re-added because of CVS problems.
 
 Revision 1.1  2006/04/11 14:36:35  richard
 Added the file.
 
 
 */
package se.lth.cs.nlp.nlputils.core;

/**
 * A callable one-argument procedure.
 * 
 * @author Richard Johansson (richard@cs.lth.se)
 */
public abstract class Procedure<T> {
    
    /**
     * Initiation parameter.
     */
    protected Object in;
    
    /**
     * Initiates the procedure.
     */
    public Procedure() {
    }
    
    /**
     * Initiates the procedure with a parameter.
     * 
     * @param in an initiation parameter.
     */
    public Procedure(Object in) {
        this.in = in;
    }
    
    /**
     * Calls this procedure.
     * 
     * @param t the parameter.
     */
    public abstract void apply(T t);
    
}
