package se.lth.cs.nlp.nlputils.core;

public class SimpleBitSet {

    long l1, l2, l3, l4;
    
    public SimpleBitSet copy() {
        SimpleBitSet out = new SimpleBitSet();
        out.l1 = l1;
        out.l2 = l2;
        out.l3 = l3;
        out.l4 = l4;
        return out;
    }
    
    public SimpleBitSet add(int n) {
        if(n < 0 || n > 255)
            throw new IllegalArgumentException("requires 0 <= n < 256");
        SimpleBitSet out = new SimpleBitSet();
        out.l1 = l1;
        out.l2 = l2;
        out.l3 = l3;
        out.l4 = l4;
        if(n < 64)
            out.l1 |= (1L << n);
        else if(n < 128)
            out.l2 |= (1L << (n - 64));
        else if(n < 192)
            out.l3 |= (1L << (n - 128));
        else
            out.l4 |= (1L << (n - 192));        
        return out;
    }
    
    public boolean contains(int n) {
        if(n < 0 || n > 255)
            throw new IllegalArgumentException("requires 0 <= n < 256");
        if(n < 64)
            return (l1 & (1L << n)) != 0;
        else if(n < 128)
            return (l2 & (1L << n - 64)) != 0;
        else if(n < 192)
            return (l3 & (1L << n - 128)) != 0;
        else
            return (l4 & (1L << n - 192)) != 0;
    }
    
    public static void main(String[] argv) {
        SimpleBitSet s = new SimpleBitSet().add(220).add(30).add(120).add(120).add(90).add(150);
        
        System.out.println(s.contains(30));
        System.out.println(s.contains(90));
        System.out.println(s.contains(120));
        System.out.println(s.contains(150));
        System.out.println(s.contains(220));
        
    }
    
}
