/*
 StackTree.java
  
 Created on Sep 18, 2006 by Richard Johansson (richard@cs.lth.se).

 $Log: StackTree.java,v $
 Revision 1.1  2009/01/16 10:05:11  johansson
 Added to brenta repository.

 Revision 1.1  2006/09/18 11:59:53  richard
 Added.

   
 */
package se.lth.cs.nlp.nlputils.core;

import java.util.LinkedList;

/**
 * @author Richard Johansson (richard@cs.lth.se)
 */
public class StackTree<T> {

	public StackTree<T> prev;
	public T top;

	public T first() {
		return top;
	}
	
	public StackTree<T> pop() {
		return prev;
	}
	
	public StackTree<T> push(T t) {
		StackTree<T> out = new StackTree<T>();
		out.top = t;
		out.prev = this;
		return out;
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("[Stack: ");
		LinkedList<T> l = new LinkedList<T>();
		StackTree<T> t = this;
		while(t != null) {
			l.addFirst(t.top);
			t = t.prev;
		}
		for(T x: l)
			sb.append(x + " ");
		sb.append("]");
		return sb.toString();
	}

}