/*
 Triple.java
 
 Created on Jan 11, 2006 by Richard Johansson (richard@cs.lth.se).
 
 $Log: Triple.java,v $
 Revision 1.1  2009/01/16 10:05:11  johansson
 Added to brenta repository.

 Revision 1.3  2006/11/06 08:14:42  richard
 Added clone.

 Revision 1.2  2006/09/07 17:51:19  richard
 New revision.

 Revision 1.1  2006/05/16 13:38:13  richard
 Re-added because of CVS problems.
 
 Revision 1.2  2006/04/07 14:46:08  richard
 Added documentation.
 
 Revision 1.1  2006/02/23 09:46:33  richard
 Added the file.
 
 
 */
package se.lth.cs.nlp.nlputils.core;

/**
 * A triple consisting of three elements.
 * 
 * @author Richard Johansson (richard@cs.lth.se)
 */
public class Triple<T1, T2, T3> {
    
    public T1 first;
    public T2 second;
    public T3 third;
    
    public Triple(T1 first, T2 second, T3 third) {
        this.first = first;
        this.second = second;
        this.third = third;
    }
     
    public String toString() {
        return "(" + first + ", " + second + ", " + third + ")";
    }

    public int hashCode() {
        return 31 * 31 * first.hashCode() + 31 * second.hashCode() + third.hashCode();
    }

    public Triple<T1, T2, T3> clone() {
        return new Triple<T1, T2, T3>(first, second, third);
    }
    
}
