
package se.lth.cs.nlp.nlputils.core;

import java.util.*;
import java.io.*;
import java.awt.Color;

public class X11Colors {
    
    private static final String X11_RGB_FILE = "/etc/X11/rgb.txt";

    private static HashMap<String, int[]> db;

    private static void init() {
	try {
	    db = new HashMap();
	    BufferedReader br = Util.openFileReader(X11_RGB_FILE);
	    String line = br.readLine();
	    while(line != null) {
		if(!line.startsWith("!")) {
		    line = line.toLowerCase().trim();
		    String[] ss = line.split("\\s+");
		    int[] rgb = new int[3];
		    rgb[0] = Integer.parseInt(ss[0]);
		    rgb[1] = Integer.parseInt(ss[1]);
		    rgb[2] = Integer.parseInt(ss[2]);
		    db.put(ss[3], rgb);
		}
		line = br.readLine();
	    }
	} catch(Exception e) {
	    throw new RuntimeException(e);
	}
    }

    public static int[] getRGB(String name) {
	name = name.toLowerCase();
	if(name.startsWith("#")) {
	    String rh= name.substring(1, 3);
	    String gh = name.substring(3, 5);
	    String bh = name.substring(5, 7);
	    int r = Integer.parseInt(rh, 16);
	    int g = Integer.parseInt(gh, 16);
	    int b = Integer.parseInt(bh, 16);
	    return new int[] { r, g, b };
	}
	if(db == null)
	    init();
	return db.get(name);
    }

    public static Color getColor(String name) {
	int[] rgb = getRGB(name);
	if(rgb == null)
	    return null;
	return new Color(rgb[0], rgb[1], rgb[2]);
    }    

}