package se.lth.cs.nlp.nlputils.math;

public class McNemarTest {

	private static double[][] testValues = {
		{ 19.51, 0.99999 },
		{ 16.45, 0.99995 },
		{ 15.14, 0.9999 },
		{ 12.1, 0.9995 },
		{ 10.8, 0.999 },
		{ 7.88, 0.995 },
		{ 6.63, 0.99 },
		{ 5.6455, 0.9825 },
		{ 5.02, 0.975 },
		{ 4.3276, 0.9625 },
		{ 3.8415, 0.95 },
		{ 3.6821, 0.945 },
		{ 3.5374, 0.94 },
		{ 3.1701, 0.925 },
		{ 2.7055, 0.9 },
	};
	
	public static double getConfidence(int a, int b, int c, int d) {
		double test = (b-c)*(b-c)/(b+c);
		for(int i = 0; i < testValues.length; i++) {
			if(test > testValues[i][0])
				return testValues[i][1];
		}
		return 0;
	}
	
	public static double getConfidence(int[][] m) {
		return getConfidence(m[0][0], m[0][1], m[1][0], m[1][1]);
	}
}
