
package se.lth.cs.nlp.nlputils.ml_long;

import java.util.Random;
import se.lth.cs.nlp.nlputils.core.RandomInfiniteSet;

public class AntagonisticFeatureFilter extends FeatureFilter {

	private double minHide;
	private RandomInfiniteSet rs;
	private LinearModelCorrupted lm;

	public AntagonisticFeatureFilter(Random rand, int neglogprob, LinearModelCorrupted lm) {
		minHide = lm.meanWeight() + lm.stddevWeight();
		rs = new RandomInfiniteSet(rand, neglogprob);
		this.lm = lm;
	}

	public boolean hides(long l) {
		if(!rs.contains(l))
			return false;
		double w = lm.getWeight(l);
		return Math.abs(w) > minHide;
	}

}
