package se.lth.cs.nlp.nlputils.ml_long;

import java.util.*;

public class CVDiscretizer {

    public static ArrayList<SparseVector> toSVs(Collection<float[]> cvs) {
        int dim = cvs.iterator().next().length;
        
        double[] sums = new double[dim];
        double[] sqsums = new double[dim];
        int n = 0;
        
        for(float[] v: cvs) {
            for(int i = 0; i < dim; i++) {
                sums[i] += v[i];
                sqsums[i] += v[i]*v[i];
                n += 1;
            }
        }

        float[] means = new float[dim];
        for(int i = 0; i < dim; i++)
            means[i] = (float) (sums[i] / n);

        float[] stds = new float[dim];
        for(int i = 0; i < dim; i++)
            stds[i] = (float) Math.sqrt((sqsums[i]-sums[i]*sums[i]/n)/(n-1));

        // är den korrekt uträknad?
        
        ArrayList<SparseVector> out = new ArrayList();
        for(float[] v: cvs) {
            SparseVector sv = new SparseVector();
            for(int i = 0; i < dim; i++) {
                float vi = v[i] - means[i];
                if(vi > stds[i]) {
                    sv.put(1 + 4*i);
                    if(vi > 2*stds[i])
                        sv.put(1 + 4*i + 1);
                }
                else if(vi < -stds[i]) {
                    sv.put(1 + 4*i + 2);
                    if(vi < -2*stds[i])
                        sv.put(1 + 4*i + 3);
                }
            }
            out.add(sv);
        }

        return out;
    }
    
}
