package se.lth.cs.nlp.nlputils.ml_long;

public class EncodedCandidateSet implements java.io.Serializable {

	private static final long serialVersionUID = 0L;
	
	public double[] costs;
	public SparseVector[] reps;
	
	public String toString() {
		StringBuilder sb = new StringBuilder("[");
		for(int i = 0; i < costs.length; i++) {
			if(i > 0)
				sb.append(", ");
			sb.append(reps[i].index + ", " + costs[i]);
		}
		sb.append("]");
		return sb.toString();
	}

	public void print() {
		for(int i = 0; i < costs.length; i++) {
			System.out.println(costs[i] + "\t" + reps[i].index + "\t" + reps[i]);
		}
	}
	
	/**
	 * Note that the sparse vectors must be sorted.
	 * @param index
	 */
	public void subtractOne(int index) {
		SparseVector op = reps[index];
        for(int i = 0; i < reps.length; i++) {
        	SparseVector sv = new SparseVector();
        	SparseVector.sortedSubtract(sv, reps[i], op);
        	sv.trim();
        	reps[i] = sv;
        }
	}
	
}
