/*
 FeatureExtractor.java
 
 Created on Dec 22, 2005 by Richard Johansson (richard@cs.lth.se).
 
 $Log: FeatureExtractor.java,v $
 Revision 1.1  2009/01/16 10:06:48  johansson
 Added to brenta repository.

 Revision 1.1  2008/05/16 12:16:04  richard
 Branched.

 Revision 1.8  2007/10/08 12:31:34  richard
 Refactored again to remove atoms.

 Revision 1.7.2.1  2007/10/08 12:19:04  richard
 Refactored again to remove atoms.

 Revision 1.7  2007/09/28 14:47:53  richard
 Refactored to atom-based.

 Revision 1.6  2006/09/18 15:17:17  richard
 Serializable.

 Revision 1.5  2006/09/08 15:31:50  richard
 Parametrized FeatureList.

 Revision 1.4  2006/09/07 17:51:19  richard
 New revision.

 Revision 1.3  2006/04/11 12:06:36  richard
 Added documentation.
 
 Revision 1.2  2006/04/11 09:30:46  richard
 Added documentation. Changed the API of the extractFeatures method.
 
 Revision 1.1  2006/01/13 13:19:37  richard
 Added the file.
 
 
 */
package se.lth.cs.nlp.nlputils.ml_long;

/**
 * Abstract class that represents the mapping from an item to a list of
 * feature values.
 * 
 * @author Richard Johansson (richard@cs.lth.se)
 */
public abstract class FeatureExtractor<T> implements java.io.Serializable {    
    
    /**
     * Extracts features of an item to a FeatureList.
     * 
     * @param item the item to classify.
     * @param list the feature list.
     * @return a status integer.
     */
    public abstract void extractFeatures(T item, FeatureList list);
    
}