/*
 FeatureListEncoder.java
  
 Created on Apr 1, 2008 by Richard Johansson (richard@cs.lth.se).

 $Log: FeatureListEncoder.java,v $
 Revision 1.3  2010-06-07 11:29:59  johansson
 Added.

 Revision 1.2  2009/03/06 13:22:01  johansson
 Added decode.

 Revision 1.1  2009/01/16 10:06:48  johansson
 Added to brenta repository.

 Revision 1.1  2008/05/16 12:16:04  richard
 Branched.

 Revision 1.3  2008/04/02 11:23:29  richard
 Abstract.

   
 */
package se.lth.cs.nlp.nlputils.ml_long;

import gnu.trove.TIntIntHashMap;

/**
 * @author Richard Johansson (richard@cs.lth.se)
 */
public abstract class FeatureListEncoder {
    
    public abstract void encode(FeatureList list, SparseVector sv);

    public Object decode(int encoded) {
        throw new UnsupportedOperationException("Unimplemented");
    }
    
    public abstract void remap(TIntIntHashMap m);    
    public abstract FeatureListEncoder clone();
    public void freeze() {}
    
}
