/*
 LongEncoder.java
  
 Created on March 19, 2009 by Richard Johansson (johansson@disi.unitn.it).

 $Log: LongEncoder.java,v $
 Revision 1.2  2011-05-26 09:27:51  johansson
 Added decode.

 Revision 1.1  2009/03/20 11:49:31  johansson
 Added.

   
 */
package se.lth.cs.nlp.nlputils.ml_long;

import gnu.trove.*;

import java.io.Serializable;
import se.lth.cs.nlp.nlputils.core.*;


/**
 * @author Richard Johansson (richard@cs.lth.se)
 */
public class LongEncoder implements Serializable {

    private static final long serialVersionUID = 0L;

    private TLongIntHashMap encoding = new TLongIntHashMap();

    private int size = 0;
    private boolean frozen = false;
    
    public LongEncoder() {
    }

    public int encode(long l) {
        int encoded = encoding.get(l);
        if(encoded == 0 && !frozen) {
            encoded = ++size;
            encoding.put(l, encoded);
        }

        if(encoded == 0) {
            //System.out.println("(" + c + ", " + a + ") -> " + encoded);
            //System.exit(1);
        }
        
        return encoded;
    }
    
    public void freeze() {
        frozen = true;
    }
    
    public int size() {
        return encoding.size();
    }
    
    public long decode(int encoded) {    
    	TLongIntIterator it = encoding.iterator();
    	for(int i = encoding.size(); i-- > 0; ) {
    		it.advance();
    		if(it.value() == encoded)         
    			return it.key();
    	}
    	return Long.MIN_VALUE;
    }
    
}
