/*
 MLConstants.java
 
 Created on Mar 30, 2006 by Richard Johansson (richard@cs.lth.se).
 
 $Log: MLConstants.java,v $
 Revision 1.2  2010-06-07 11:29:59  johansson
 Added.

 Revision 1.1  2009/01/16 10:06:48  johansson
 Added to brenta repository.

 Revision 1.1  2008/05/16 12:16:04  richard
 Branched.

 Revision 1.4  2008/04/02 11:21:58  richard
 Strings instead of chars.

 Revision 1.3  2006/09/07 17:51:19  richard
 New revision.

 Revision 1.2  2006/04/11 09:35:02  richard
 Added documentation.
 
 Revision 1.1  2006/04/05 11:42:40  richard
 Added the file.
 
 
 */
package se.lth.cs.nlp.nlputils.ml_long;

/**
 * Declares some public constants.
 * 
 * @author Richard Johansson (richard@cs.lth.se)
 */
public class MLConstants {
    
    private MLConstants() {}
    
    /**
     * This character is used to separate features in a feature string.
     */
    public static final char FEATURE_SEPARATOR = '|';
    
    /**
     * This value is used to replace the feature separator in strings.
     */
    //static final char ESCAPE_FEATURE_SEPARATOR = Character.MAX_VALUE - 1;
    
    static final String ESCAPE_FEATURE_SEPARATOR = "__PIPE__";
    
    /**
     * This character is used to separate members in a set-valued feature.
     */
    public static final char SET_SEPARATOR = '#';

    //static final char ESCAPE_SET_SEPARATOR = Character.MAX_VALUE - 2;
    static final String ESCAPE_SET_SEPARATOR = "__NBR__";
    
    /**
     * This string signifies the empty set for a set-valued feature.
     */
    public static final String EMPTY_SET = "<E>";
    
    /**
     * This number signifies that a member of a feature set is excluded.
     */
    public static final int EXCLUDED_MAGIC_NUMBER = Integer.MIN_VALUE + 12345;
    
}
