/*
 Majority.java
  
 Created on Apr 3, 2008 by Richard Johansson (richard@cs.lth.se).

 $Log: Majority.java,v $
 Revision 1.2  2010-06-07 11:30:23  johansson
 Major update.

 Revision 1.1  2009/01/16 10:06:48  johansson
 Added to brenta repository.

 Revision 1.1  2008/05/16 12:16:05  richard
 Branched.

 Revision 1.1  2008/04/07 12:12:11  richard
 Added.

   
 */
package se.lth.cs.nlp.nlputils.ml_long.algorithms;

import java.util.*;

import se.lth.cs.nlp.nlputils.core.*;
import se.lth.cs.nlp.nlputils.ml_long.*;
import se.lth.cs.nlp.nlputils.ml_long.classifiers.UnaryClassifier;

/**
 * @author Richard Johansson (richard@cs.lth.se)
 */
public class Majority<I, V> extends LearningAlgorithm<MulticlassDefinition<I, V>, I, V> {

    public Majority(String[] argv, int offset) {
        for(int i = offset; i < argv.length; i++) {
        }
    }

    public Classifier<I, V> train(MulticlassDefinition<I, V> spec, List<Pair<I, V>> trainingSet) { 
    	boolean restricted = (trainingSet.get(0).left instanceof RestrictedInstance);    	
    	Histogram<V> hist = new Histogram();
        for(Pair<?, V> p: trainingSet)
            hist.add(p.right);
        if(!restricted)
        	return new UnaryClassifier<I, V>(hist.getMostFrequent());
        else {
        	final ArrayList<V> l = new ArrayList();
        	for(IntObjPair<V> p: hist.asSortedList())
        		l.add(p.right);
        	return new Classifier<I, V>() {
        		private static final long serialVersionUID = 0L;
        		public V classify(Object o) {
        			RestrictedInstance<I, V> inst = (RestrictedInstance) o;
        			for(V v: l)
        				if(CollectionUtils.contains(inst.range, v))
        					return v;
        			return inst.range[0];
        		}
        	};
        }        

    }
    
}
