package se.lth.cs.nlp.nlputils.ml_long.featuresearch;

import java.util.HashSet;

import se.lth.cs.nlp.nlputils.core.Pair;

public class StartSets {

	public static Pair<HashSet<String>, HashSet<Pair<String, String>>> 
	parseStartSet(String arg) {

		arg = arg.trim();

		if(!arg.startsWith("{") || !arg.endsWith("}"))
			throw new IllegalArgumentException("Illegal set format");

		arg = arg.substring(1, arg.length() - 1).trim();

		String[] ss = arg.split(",\\s*");

		HashSet<String> fs = new HashSet();
		HashSet<Pair<String, String>> ps = new HashSet();

		for(int i = 0; i < ss.length; i++) {        
			String s = ss[i];
			if(s.startsWith("(")) {
				if(i == ss.length - 1)
					throw new IllegalArgumentException("Illegal pair format " + s);
				String s2 = ss[++i];
				if(!s2.endsWith(")"))
					throw new IllegalArgumentException("Illegal pair format " + s2);
				s = s.substring(1);
				s2 = s2.substring(0, s2.length() - 1).trim();
				if(s.equals("") || s2.equals(""))
					throw new IllegalArgumentException("Illegal pair format (empty)");
				ps.add(new Pair(s, s2));
			} else
				fs.add(s);
		}

		return new Pair(fs, ps);
	}
	
}
