package se.lth.cs.nlp.opinions;

import se.lth.cs.nlp.nlputils.ml_long.*;
import java.util.*;

public class TaggingModel implements java.io.Serializable {
	
	private static final long serialVersionUID = 1L;
	
	Classifier<Sentence, Labeling> cl;
	SymbolEncoder inEncoder;
	SymbolEncoder outEncoder;
	SeqLabelingDefinition def;
	
	ArrayList<String> labelDecoder;
	
	TaggingModel(Classifier<Sentence, Labeling> cl,
			SymbolEncoder le, SymbolEncoder we, SeqLabelingDefinition def) {
		this.cl = cl;
		this.def = def;
		this.inEncoder = we;
		this.outEncoder = le;
		this.labelDecoder = outEncoder.inverse();
	}

	public int inEncode(String symbol) {
		return inEncoder.encode(symbol);
	}
	
}
